/* 
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

  STARTER PROGRAM

 *
 * Section BH
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS		9


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0

/*	Mouse click upon the car */
#define CAR_CLICK 2

/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define NUM_VEHICLES 2

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40

/* And of a single jet */
#define JET_HEIGHT 12
#define JET_WIDTH  45

/* Car Modes*/
#define CAR 1
#define JET (-1)
#define TRUCK 0

/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/*Draw the random mole*/
void draw_mole(int mole_x, int mole_y);

/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y, int *day);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y, int car_x,
						  int car_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, int 
				   *car_speed, int *car_direction, 
				   int *car_color, int *mode, int *car_x,
				   int *car_y, int *vehicle, int *psychadelic);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y, int *day);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int *x, int *y, int *direction, int speed,
				  int mode, int *color, int psychadelic,
				  int new_color);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x, int y, int color, int mode, int direction);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color, int mode, int direction);

/* Display error message if internal error is detected. */
void something_is_wrong (void);

void transform (int *mode, int *x, int *y, int vehicle);

void pause(clock_t wait);

typedef struct {
	int x;
	int y;
	int speed;
	int mode;
	int direction;
	int color;
	int psychadelic;/*for turning color cycling on*/

} vehicle;


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	/* Information about the sun: */
	int sun_x, sun_y, day;	/* screen x and y coordinates */

	/* Information about vehicles in the animation:							*/
	int traffic_moving;		/* = "traffic is currently moving"				*/
	int mole, r, s;			/* Has a mole popped up? */
	int mole_x, mole_y;
	int mode;				/*What mode the car is in*/
	int crash_counter;		/*oops, did you hit the mole?*/
	int i;					/* A simple counter variable*/
	int vc = 1;				/* Short for Vehicle Controlled*/
	int new_color;			/* New colors, of course */

	vehicle car[NUM_VEHICLES];	/*The vehicles*/

	/* I prefer this random number initializer */
	srand( (unsigned) time (NULL) );

	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;
	day = TRUE;
	
	/* No Mole around right now*/
	mole = FALSE;
	
	/* The vehicle is a car*/
	mode = CAR;

	/* set initial conditions for the car */
	traffic_moving = TRUE;
	
	/*
	If you want to force a collision, un-comment this
	and comment out the random assignment.
	mole_x = 0;
	mole_y = HIGHWAY_CENTER + 15;*/
	
	mole_x = rand()%(2*GP142_XMAX) - GP142_XMAX;
	mole_y = -rand()%(GP142_YMAX);	
	
	while (mole_y>HIGHWAY_CENTER)
	{
		mole_x = rand()%(2*GP142_XMAX) - GP142_XMAX;
		mole_y = -rand()%(GP142_YMAX);	
	}

		
	for (i=0;i<NUM_VEHICLES;i++)
	{
		car[i].x = 0 + CAR_WIDTH * 3 * i;
		if (i%2 == 0)
			car[i].y = HIGHWAY_CENTER ;
		else car[i].y = HIGHWAY_CENTER - CAR_WIDTH/4;
		if (i%2 == 0)
			car[i].direction = -1;
		else car[i].direction = +1;
		car[i].speed	= 4 + rand()%3;
		car[i].color = RED + i;
		car[i].mode  = CAR;
		car[i].psychadelic = FALSE;
	}/*End for loop*/


	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(sun_x,sun_y, &day);
	draw_buttons();
	for (i=0;i<NUM_VEHICLES;i++)
	{
		draw_traffic(car[i].x, car[i].y, car[i].color, 
			car[i].mode, car[i].direction);
	}
	

	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y,
				car[vc].x, car[vc].y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving, 
					&car[vc].speed,	&car[vc].direction,
					&car[vc].color, &car[vc].mode, &car[vc].x,
					&car[vc].y, &vc, &car[vc].psychadelic);
			} else if (click_kind == CAR_CLICK)
			{
				transform(&car[vc].mode, &car[vc].x, &car[vc].y, vc);
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y, &day);
			if (traffic_moving)
				for (i=0;i<NUM_VEHICLES;i++)
				{
					new_color = rand()%23;
					move_traffic(&car[i].x, &(car[i].y), 
						&(car[i].direction), car[i].speed, 
						car[i].mode, &car[i].color, 
						car[i].psychadelic, new_color);
				}
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		r = rand()%100;
		if (r < 2)
			mole = TRUE;
						
		/* Redraw everything */
		draw_landscape(sun_x, sun_y, &day);
		draw_buttons();
		for (i=0;i<NUM_VEHICLES;i++)
		{
			draw_traffic(car[i].x, car[i].y, car[i].color, 
				car[i].mode, car[i].direction);
		}
	
		if (mole == TRUE)
		{
			draw_mole(mole_x, mole_y);
			s = rand()%100;
			if (s > 96)
			{
				mole = FALSE;
				mole_x = rand()%(2*GP142_XMAX) - GP142_XMAX;
				mole_y = rand()%(GP142_YMAX) - GP142_YMAX; 
				while (mole_y > HIGHWAY_CENTER)
				{
					mole_x = rand()%(2*GP142_XMAX) - GP142_XMAX;
					mole_y = rand()%(GP142_YMAX) - GP142_YMAX; 
				}
			}/*endif*/
				
		}/*endif*/
			for (i=0;i<NUM_VEHICLES;i++)
			{
				if ((abs((mole_x - car[i].x)) < 20) && 
					(abs((mole_y - car[i].y)) < 20) && 
					mole == TRUE)
		
				{
					
					for (crash_counter=0;crash_counter<5000;
						crash_counter++)
					{
						GP142_printfXY(BLACK, -50, HORIZON,
						20, "COLLISION!");
					}
				mole = FALSE;
				mole_x = rand()%(2*GP142_XMAX) - GP142_XMAX;
				mole_y = rand()%(GP142_YMAX) - GP142_YMAX; 
				car[i].speed = 0;
				}/*endif*/
			}/*End for loop*/

	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y, int *day)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */
	int i;								/* A counter */

	/* Draw the sky and sun/moon, for night or day */
	
	if (*day == TRUE)
	{

		GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
			GP142_XMAX, GP142_YMAX, FILL);
		
		GP142_circleXY(YELLOW, sun_x, sun_y , 20);
	}/*Endif*/

	else if (*day == FALSE)
	{
		GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX,
			GP142_XMAX, GP142_YMAX, FILL);
		
		GP142_circleXY(WHITE, sun_x, sun_y , 17);
	}

	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(FOREST_GREEN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
	GP142_rectangleXY(MED_GRAY, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);
	GP142_lineXY (YELLOW, -GP142_XMAX, HIGHWAY_CENTER,
					 GP142_XMAX, HIGHWAY_CENTER, 2);	
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.");
	GP142_lineXY (MED_GRAY,
		100, HIGHWAY_CENTER - CAR_WIDTH/4 + 1,
		-180, -GP142_YMAX,
		15);
	

	/*Draw some mountains */
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);

	GP142_triangleXY(MED_GRAY,
		GP142_XMAX/4, GP142_YMAX/3,
		GP142_XMAX, GP142_YMAX/3,
		3 * GP142_XMAX/4, (7 * GP142_YMAX)/10 ,
		FILL);

	GP142_triangleXY(MED_GRAY,
		0, GP142_YMAX/3,
		GP142_XMAX, GP142_YMAX/3,
		GP142_XMAX/2, (67 * GP142_YMAX)/100,
		FILL);
	
	GP142_triangleXY(MED_GRAY,
		0, GP142_YMAX/3,
		-GP142_XMAX, GP142_YMAX/3,
		-GP142_XMAX/2, (67 * GP142_YMAX)/100,
		FILL);

	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX, HORIZON,
		0, HORIZON,
		-GP142_XMAX, 75 * GP142_YMAX/100,
		FILL);

	GP142_triangleXY(FOREST_GREEN,
		-( 3 * GP142_XMAX)/4, HORIZON,
		(3 * GP142_XMAX)/2, HORIZON,
		0, GP142_YMAX/3,
		FILL);

	GP142_triangleXY(FOREST_GREEN,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);

/*Draw House*/
	GP142_rectangleXY(WHITE,
		-200, -200,
		-150, -170,
		FILL);
	GP142_rectangleXY(BROWN,
		-200, -170,
		-190, -150,
		FILL);
	GP142_triangleXY(RED,
		-145, -170,
		-205, -170,
		-175, -150,
		FILL);
	GP142_rectangleXY(BROWN,
		-185, -198,
		-195, -180,
		FILL);
	GP142_rectangleXY(BLUE,
		-180, -180,
		-155, -195,
		FILL);
	GP142_lineXY(WHITE,
		-180, -188,
		-155, -188,
		1);
	GP142_lineXY(WHITE,
		-168, -180,
		-168, -195,
		1);

	/* Draw Trees*/

	for (i=-GP142_XMAX;i<GP142_XMAX;i=i+GP142_XMAX/5)
	{
		GP142_rectangleXY(BROWN,
			i, HIGHWAY_CENTER + 15,
			i + 10, HIGHWAY_CENTER + 35,
			FILL);
		GP142_circleXY(OLIVE,
			i + 5, HIGHWAY_CENTER + 55,
			25);
	}

	/*Draw River*/
	GP142_lineXY(BLUE,
		GP142_XMAX, -(2 * GP142_YMAX)/3,
		(3 * GP142_XMAX)/4, -(8 * GP142_YMAX)/10,
		18);
	GP142_lineXY(BLUE,
		(3 * GP142_XMAX)/4, -(8 * GP142_YMAX)/10,
		GP142_XMAX/4,  -(8 * GP142_YMAX)/10,
		16);
	GP142_lineXY(BLUE,
		GP142_XMAX/4,  -(8 * GP142_YMAX)/10,
		-GP142_XMAX/8, -GP142_YMAX,
		16);
} /*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLUE,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLUE, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLUE, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLUE, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLUE, text_offset, i, font_size, "New Color");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLUE, text_offset, i, font_size, "Transform");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLUE, text_offset, i, font_size, "Switch Cars");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLUE, text_offset, i, 3*font_size/4, "PSYCHADELIC");
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y, int car_x,
						  int car_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	if ((abs(mouse_x - car_x) < 20) &&
		(abs(mouse_y - car_y) < 20))
		return CAR_CLICK;	
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, 
				   int *car_speed, int *car_direction, 
				   int *car_color, int *mode, int *car_x,
				   int *car_y, int *vehicle, int *psychadelic)
{
	int buttonNum;		/* number of selected button */
	
	
	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - abs(y))/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		if (*car_speed == 0)
			*car_speed = 6;
		break;
	case 1:
		/* stop */
		if (*mode == CAR)
			*car_speed = 0;
		break;
		
	case 2:
		/* speed up */
		*car_speed = *car_speed + 1;
		break;
	case 3:
		/* slow down */
		*car_speed = *car_speed - 1;
		if (*car_speed < 0)
			*car_speed = 0;
		break;
		
	case 4:
		/* reverse */
		if (*mode != JET)
			*car_direction = - *car_direction;
		break;
	case 5:
		/* change car color */
		*car_color = (*car_color+1) % MAX_COLORS;
		break;
	case 6:
		/* transform */
		transform(mode, car_x, car_y, *vehicle);
		break;
	case 7:
		/* Switch Cars */
		if (*vehicle == 0) 
			*vehicle = 1;
		else if (*vehicle == 1)
			*vehicle = 0;
		break;
	case 8:
		/*Turn on psychadelic cars*/
		if (*psychadelic==TRUE)
			*psychadelic = FALSE;
		else if (*psychadelic == FALSE)
			*psychadelic = TRUE;
		break;
	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y, int *day) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) --;
	if (*sun_x < -GP142_XMAX -30) 
	{
		*sun_x = - *sun_x;
		(*sun_y) --;
		if (*day == TRUE)	
			*day = FALSE;
		else if (*day == FALSE)
			*day = TRUE;
	}
}


/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int *x, int *y, int *direction, int speed,
				  int mode, int *color, int psychadelic,
				  int new_color) {
	/* Note: If there is more than one vehicle, this should */
	/* be updated to adjust all vehicle coordinates */

	int trial_x;		/* new value for x coordinate */
	
	/* move vehicle.  If it moves off the edge, reverse direction */
	if (mode == CAR) 
		trial_x = *x + (*direction * speed);
	else if (mode == JET)
		trial_x = *x + (*direction * 2 * speed);
	else if (mode == TRUCK)
		trial_x = *x + (*direction * speed);

	if (abs(trial_x) > GP142_XMAX - CAR_WIDTH/2)
	{	
		*color = new_color;
		*x = -*x;
	}
	else
		*x = trial_x;
	
	if (psychadelic == TRUE)
		*color = new_color;
		
	
}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x, int y, int color, int mode, int direction) {
	/* Note: needs to be changed if there is more than */
	/* one vehicle */

	draw_car(x,y,color,mode, direction);
}



/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color, int mode, int direction) {
	
	
	if (mode == CAR){
	GP142_rectangleXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH/2, y + CAR_HEIGHT*3/4, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH/6, y + CAR_HEIGHT*3/4,
						x + CAR_WIDTH/6, y + CAR_HEIGHT, FILL);
		if (color != BLACK)
		{
			GP142_circleXY(BLACK, x - CAR_WIDTH/4,
				y + CAR_HEIGHT/4, CAR_HEIGHT/4);
			GP142_circleXY(BLACK, x + CAR_WIDTH/4,
				y + CAR_HEIGHT/4, CAR_HEIGHT/4);
		}
		else 
		{
			GP142_circleXY(BROWN, x - CAR_WIDTH/4,
				y + CAR_HEIGHT/4, CAR_HEIGHT/4);
			GP142_circleXY(BROWN, x + CAR_WIDTH/4,
				y + CAR_HEIGHT/4, CAR_HEIGHT/4);
		}
	}
	
	/*This probably could have been done better by multiplying
	the coordinates by direction*/
	if (mode == JET){	
		if (direction == 1){
	/* Draw fuselage */
	GP142_rectangleXY(color, x - JET_WIDTH/2, y + JET_HEIGHT/2,
						x + JET_WIDTH/2, y - JET_HEIGHT/2, FILL);
	
	/* Draw Wings */
	GP142_rectangleXY(BLACK, x - JET_WIDTH/2 + 10, y + 20,
						x - JET_WIDTH/2 + 15, y + JET_HEIGHT/2,
						FILL);
	GP142_rectangleXY(BLACK, x - JET_WIDTH/2 + 10, y -30,
						x - JET_WIDTH/2 + 15, y - JET_HEIGHT/3,
						FILL);
	GP142_triangleXY(color,  x - JET_WIDTH/2 + 15, y -30,
						x - JET_WIDTH/2 + 15, y,
						x + JET_WIDTH/3, y, FILL);
	GP142_triangleXY(color, x - JET_WIDTH/2 + 15, y + 20,
						x - JET_WIDTH/2 + 15, y,
						x + JET_WIDTH/3, y, FILL);
	GP142_triangleXY(color, x - JET_WIDTH/2, y + JET_HEIGHT/2,
						x - JET_WIDTH/2 + JET_WIDTH/9,
						y + JET_HEIGHT/2, x - JET_WIDTH/2,
						y + JET_HEIGHT, FILL);
	

	/*Draw Engine */
	GP142_rectangleXY(BLACK, x - JET_WIDTH/2, y + JET_HEIGHT/4,
						x - JET_WIDTH/2 - 5, y - JET_HEIGHT/4, FILL);
	/*Draw Nose and Cockpit*/
	GP142_triangleXY(color, x + JET_WIDTH/2, y + JET_HEIGHT/2,
						x + JET_WIDTH/2, y - JET_HEIGHT/2, 
						x + JET_WIDTH, y, FILL);
	GP142_triangleXY(BLACK, x + JET_WIDTH/2, y + JET_HEIGHT/2,
						x + JET_WIDTH/2 + 10, y + 2*JET_HEIGHT/7,
						x + JET_WIDTH/2, y + 2*JET_HEIGHT/7, FILL);
	
		}/*endif*/
		
		else if (direction == (-1))
		{
			/* Draw fuselage */
	GP142_rectangleXY(color, x + JET_WIDTH/2, y + JET_HEIGHT/2,
						x - JET_WIDTH/2, y - JET_HEIGHT/2, FILL);
	
	/* Draw Wings */
	GP142_rectangleXY(BLACK, x + JET_WIDTH/2 - 10, y + 20,
						x + JET_WIDTH/2 - 15, y + JET_HEIGHT/2,
						FILL);
	GP142_rectangleXY(BLACK, x + JET_WIDTH/2 - 10, y -30,
						x + JET_WIDTH/2 - 15, y - JET_HEIGHT/3,
						FILL);
	GP142_triangleXY(color,  x + JET_WIDTH/2 - 15, y -30,
						x + JET_WIDTH/2 - 15, y,
						x - JET_WIDTH/3, y, FILL);
	GP142_triangleXY(color, x + JET_WIDTH/2 - 15, y + 20,
						x + JET_WIDTH/2 - 15, y,
						x - JET_WIDTH/3, y, FILL);
	GP142_triangleXY(color, x + JET_WIDTH/2, y + JET_HEIGHT/2,
						x + JET_WIDTH/2 - JET_WIDTH/9,
						y + JET_HEIGHT/2, x + JET_WIDTH/2,
						y + JET_HEIGHT, FILL);
	

	/*Draw Engine */
	GP142_rectangleXY(BLACK, x + JET_WIDTH/2, y + JET_HEIGHT/4,
						x + JET_WIDTH/2 + 5, y - JET_HEIGHT/4, FILL);
	/*Draw Nose and Cockpit*/
	GP142_triangleXY(color, x - JET_WIDTH/2, y + JET_HEIGHT/2,
						x - JET_WIDTH/2, y - JET_HEIGHT/2, 
						x - JET_WIDTH, y, FILL);
	GP142_triangleXY(BLACK, x - JET_WIDTH/2, y + JET_HEIGHT/2,
						x - JET_WIDTH/2 - 10, y + 2*JET_HEIGHT/7,
						x - JET_WIDTH/2, y + 2*JET_HEIGHT/7, FILL);
	
		}/*endif*/
	}/*endif*/

	/*draw a truck*/
	if (mode == TRUCK)
	{
		GP142_rectangleXY(color, 
			x - 7*CAR_WIDTH/12, y + CAR_HEIGHT/4,
			x + 7*CAR_WIDTH/12, y + CAR_HEIGHT*7/8, FILL);
		GP142_rectangleXY(color, 
			x - CAR_WIDTH/4, y + CAR_HEIGHT*7/8,
			x + CAR_WIDTH/4, y + CAR_HEIGHT*118/100, FILL);
		if (direction == 1)
		{	
			GP142_lineXY(LT_GRAY,
			x - CAR_WIDTH/4 -1, y + CAR_HEIGHT*7/8,
			x - CAR_WIDTH/4 -1, y + CAR_HEIGHT*130/100,
			2);
		}
		else if (direction == (-1))
		{
			GP142_lineXY(LT_GRAY,
			x + CAR_WIDTH/4 + 1, y + CAR_HEIGHT*7/8,
			x + CAR_WIDTH/4 + 1, y + CAR_HEIGHT*138/100,
			2);
		}
		GP142_circleXY(BLACK, 
			x - CAR_WIDTH/3, y + CAR_HEIGHT/3,
			45*CAR_HEIGHT/100);
		GP142_circleXY(BLACK,
			x + CAR_WIDTH/3, y + CAR_HEIGHT/3,
			45*CAR_HEIGHT/100);
		GP142_circleXY(LT_GRAY,
			x - CAR_WIDTH/3, y + CAR_HEIGHT/3,
			15*CAR_HEIGHT/100);
		GP142_circleXY(LT_GRAY,
			x + CAR_WIDTH/3, y + CAR_HEIGHT/3,
			15*CAR_HEIGHT/100);
	}/*End if truck*/
}/*end draw car*/

/* Draw a Mole with a mining hat */
void draw_mole(int mole_x, int mole_y)
{		
	
	GP142_ovalXY		(BLACK, mole_x + 15, mole_y,
							mole_x - 15, mole_y - 17, FILL);
	GP142_ovalXY		(BROWN, mole_x + 6, mole_y - 2,
							mole_x - 6, mole_y - 14, FILL);
	GP142_circleXY		(BROWN, mole_x, mole_y, 7);
	GP142_circleXY		(WHITE, mole_x + 5, mole_y + 5, 2);
	GP142_circleXY		(WHITE, mole_x - 5, mole_y + 5, 2);
	GP142_circleXY		(BLACK, mole_x + 5, mole_y + 5, 1);
	GP142_circleXY		(BLACK, mole_x - 5, mole_y + 5, 1);
	GP142_rectangleXY	(YELLOW, mole_x - 10, mole_y + 16,
							mole_x + 10, mole_y + 8, FILL);
	GP142_circleXY		(WHITE, mole_x, mole_y + 12, 3);
	GP142_ovalXY		(BLACK, mole_x + 3, mole_y + 15,
							mole_x - 3, mole_y + 9, 1);
	GP142_lineXY		(BLACK, mole_x + 3, mole_y - 3,
							mole_x - 3, mole_y -3, 1);
	GP142_lineXY		(BROWN, mole_x + 5, mole_y - 5,
							mole_x + 15, mole_y - 5, 2);
	GP142_lineXY		(BROWN, mole_x + 15, mole_y - 5,
							mole_x + 18, mole_y - 1, 2);
	GP142_circleXY		(BROWN, mole_x + 18, mole_y -1, 3);
	GP142_lineXY		(PEACH, mole_x + 18, mole_y + 1,
							mole_x + 18, mole_y + 19, 2);
	GP142_rectangleXY	(PEACH, mole_x - 10, mole_y + 42,
							mole_x + 46, mole_y + 16, FILL);

	GP142_printfXY		(BLACK, mole_x - 6, mole_y + 31,
							9, "MADONNA");
	GP142_printfXY		(BLACK, mole_x - 9, mole_y + 19,
							9, "FOR PREZ");
}

/* Transform the car into a jet, and vice versa */

void transform (int *mode, int *car_x, int *car_y, int vehicle)
{

	pause(100);

	if (*mode == CAR && vehicle%2 == 0)
	{
		*car_y = *car_y + GP142_YMAX;
		*mode = JET;
	}
	else if (*mode == CAR && vehicle%2 == 1)
		*mode = TRUCK;
	else if (*mode == JET)
	{
		*car_y = HIGHWAY_CENTER;
		*mode = CAR;
	}
	else if (*mode == TRUCK)
	{
		*mode = CAR;
	}
}


/*****************************************************************************

     OTHER

*****************************************************************************/


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}

/*Pause*/
void pause(clock_t wait)
{
   clock_t goal;
   goal = wait + clock();
   while(goal > clock());
}

